<?php
//===================================================================================
///                                              Fichier : DocXml_ModeleFicheXML.php
///===================================================================================
///
///   Traitement d'un modle de document XML :
///      Construction de l'affichage d'une fiche et du formulaire associ
///      en accord avec la charte graphique du site
///
///   Le code HTML associ  la prsentation d'une fiche, ou du formulaire associ,
///      est gnr par analyse des balises XML du modle et des leurs attributs.
///   Les valeurs des balises XML seront les valeurs par dfaut des mmes balises
///      XML de la fiche.
///
///   Les valeurs des balises XML du modle et de leurs attributs peuvent contenir
///      des balises HTML. Elles seront reues comme "<baliseHTML>'.
///   NB: Dans le modle de fiche rdig sous SPIP, ces mmes balises HTML devront
///       tre codes "baliseHTML" - cf. processXML() et nouvelleFiche.php
///
///   Dans le code HTML gnr par les handlers, les constructions suivantes seront
///      ensuite traites par la procdure "renseignerBalisesDsModele()" du module
///      "DocXml_FicheXML.php" :
///
///      - !x!balise!x!                  => Remplac par $valeursFiche[balise]
///      - !v!balise!v!texte!/v!         => Remplac par "texte" si $valeursFiche[balise] non vide
///      - !w!balise!w!test1;test2;...;testn!w!texte!/w!
///                                      => Remplac par "texte" si $valeursFiche[balise]="testk"
///      - !z!balise!z!sql!/z!           => Remplac par les valeurs extraites de la base par
///                                         l'instruction SQL $sql (du type "SELECT ... WHERE id IN ")
///                                         complte par les identifiants prsents dans
///                                         $valeursFiche[balise] (du type "id1,xx,xx;id2,xx,xx;id3,xx,xx")
///
///===================================================================================
///
///   Variables globales (autre que celles associes au traitement des balises XML elles-mmes)
///
///   $xml_Fiche_Formulaire   = '' si affichage d'une fiche
///                           = 'Form' si affichage d'un formulaire
///                           = 'Modele' si seult renseignement de $attributsModele
///   $xml_ProcessXML_Requete     = 'NouvelleFiche' ou 'ModifFiche' ou 'Modele'
///   $TypeDocXML         = Attribut "TypeDocXML" de la balise "DocumentXML" (cf. processXML() )
///   $lienNewFicheXML    = Lien vers l'enregistrement d'une fiche modifie  (cf. processXML() )
///   $lienModifFicheXML  = Lien vers la modification d'une fiche (cf. processXML() )
///
///   Variables globales renseignes
///
///   $attributsModele[balise][attribut] = Valeurs des attributs des balises du modle
///   $attributsModele[balise]['Defaut'] = Valeurs des balises du modle
///   $valeursFiche       Si $xml_ProcessXML_Requete='NouvelleFiche',
///                         ce tableau est renseign aux valeurs par dfaut
///                         du modle via la procdure
///                         "renseignerBalisesDsModele()" (cf. DocXml_FicheXML.php)
///
///   NB: Une mme balise ne peut apparatre 2 fois dans le modle.
///       Si tel est le besoin, les 2 balises seront numrotes "balise_NNN_";
///       Par exemple : <cadre_1_>, <cadre_2_>
///       Dans les handlers, le suffixe "_NNN_" est systmatiquement supprim avant
///       traitement de la balise.
///
//====================================================================================

//include 'Tools/classeDebug.php';
//global $debugAppli;
//$debugAppli=new DEBUG();

///====================================================================================
///    function ModeleFicheXML_startElementHandler($parser, $name, &$attribs) { global $debugAppli;
    function ModeleFicheXML_startElementHandler($parser, $name, &$attribs) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise ouvrante
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $name     Nom de la balise ouvrante
///    $attribs  Attributs de la balise
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours, $xmlDataOut;
      global $DocXmlHandler, $TypeDocXML;
      global $xml_Fiche_Formulaire;
      global $attributsModele, $lienEnrFicheXML;
//------------------------------------------------------------------------------------
///
/// Garder les balises du modle et leurs attributs


/// Restaurer le code HTML ventuellement prsent dans les attributs
          $attribsHTML = RestaurerCodeHTML($attribs);
if($debugAppli) $debugAppli->show($attribsHTML,"ModeleFicheXML_startElementHandler --- &lt;$name...>");

      foreach($attribsHTML as $attrib=>$val)
        $attributsModele[$name][$attrib] = $val;

/// Si on ne cherche que les paramtres du modle, c'est fini...
/// ... sinon, afficher la fiche ou le formulaire associ
      if($xml_Fiche_Formulaire!='Modele') {

/// Identifier les filtres spcifiques utiliss ici (attribut "Traitement")
///        NoAffInForm  Ne pas afficher l'entre dans le formulaire (=> input "hidden")
///        NoAff        Ne pas afficher l'entre dans la fiche
        if($traitements=explode(',', $attribs['Traitement']))
          foreach($traitements as $traitement)
            $$traitement = "1";   // Renseigner $<filtre>

/// Traiter les balises
        $balise = ereg_replace('_[0-9]*_$', '', $name); // Supprimer les indices utiliss
                                                        // pour diffrencier des balises identiques
        switch($balise) {

///------------------------------------------------------------------------------------
///          case 'DocumentXML' :
          case 'DocumentXML' :

/// Traiter les attributs  Evnt_xxx="..."
            $onEvnt = '';;
            foreach(array_keys($attribsHTML) as $key) {
              $evt = str_replace('Evnt_','',$key);
              if($evt!=$key) $onEvnt .= "$evt=\"".$attribsHTML[$key].'" ';
            }

if($debugAppli) $debugAppli->show($xml_Fiche_Formulaire,'xml_Fiche_Formulaire');
            if($xml_Fiche_Formulaire=='Form') {
if($debugAppli) $debugAppli->show($lienEnrFicheXML,'lienEnrFicheXML');
              $xmlDataOut .= "\n<FORM NAME='$TypeDocXML' METHOD='post' ".
                                     "ENCTYPE='multipart/form-data' ".
                                     "ACTION='$lienEnrFicheXML' ".
                                     "$onEvnt>";
            }

            if(!$BorderForm=$attribsHTML['BorderForm']) // Accepter les 2 attributs
              if(!$BorderForm=$attribsHTML['Border']) $BorderForm = 0;
            $Border = $BorderForm;
            $attributsModele['DocumentXML']['Border']     = $Border;
            $attributsModele['DocumentXML']['BorderForm'] = $Border;

            if(!$Width=$attribsHTML['Width'])   $Width = '100%';
            $Width = "WIDTH='$Width'";

            $xmlDataOut .= "\n<TABLE $Width COLS='4' BORDER='$Border' CELLPADDING='2' RULES='groups'>";
            $xmlDataOut .= "\n  <TBODY>";

            break;

///------------------------------------------------------------------------------------
///          case 'Titre' :
          case 'Titre' :

            if(($xml_Fiche_Formulaire=='Form' && !$NoAffInForm)
               || ($xml_Fiche_Formulaire!='Form' && !$NoAff)) {

/// Rcuprer les attributs de mise en page : 'Html_Titre', 'Class_Titre'
              if(!$Html_Titre=$attribsHTML['Html_Titre'])
                $Html_Titre = $attributsModele['DocumentXML']['Html_Titre'];

              if(!$Class_Titre=$attribsHTML['Class_Titre'])
                $Class_Titre = $attributsModele['DocumentXML']['Class_Titre'];
              if($Class_Titre) $Class_Titre = "CLASS='$Class_Titre'";

              if($Html_Titre)
                $xmlDataOut .= "\n<TR><TD COLSPAN='4'>$Html_Titre</TD></TR>";
              $xmlDataOut .= "\n<TR><TD COLSPAN='4' $Class_Titre>";
              $xmlDataOut .= $attribsHTML['Titre'];
              $xmlDataOut .= "</TD></TR>";

            } // Fin if(($xml_Fiche_Formulaire=='Form' && !$NoAffInForm)...

            break;

///------------------------------------------------------------------------------------
///          case 'Cadre' :
          case 'Cadre' :

            if(($xml_Fiche_Formulaire=='Form' && !$NoAffInForm)
               || ($xml_Fiche_Formulaire!='Form' && !$NoAff)) {

/// Rcuprer les attributs de mise en page : 'Html_Cadre', 'Class_Titre', 'Border'
              if(!$Html_Titre=$attribsHTML['Html_Titre'])
                $Html_Titre = $attributsModele['DocumentXML']['Html_Titre'];

              if(!$Class_Titre=$attribsHTML['Class_Titre'])
                $Class_Titre = $attributsModele['DocumentXML']['Class_Titre'];
              if($Class_Titre) $Class_Titre = "CLASS='$Class_Titre'";

              if($xml_Fiche_Formulaire=='Form')
                if(!$Border=$attribsHTML['BorderForm'])
                  $Border = $attributsModele['DocumentXML']['BorderForm'];

              if(!$Border)
                if(!$Border=$attribsHTML['Border'])
                  $Border = $attributsModele['DocumentXML']['Border'];

              if(!$Border) $Border = 0;

              $attributsModele[$name]['Border'] = $Border;     // Pour savoir comment fermer le cadre...

/// Gnrer le code HTML
              if($Border)
                $xmlDataOut .= "\n<TR><TD COLSPAN='4'>\n<TABLE CELLPADDING='5' WIDTH='100%' COLS='4' RULES='GROUPS' BORDER='$Border'>\n<TBODY>";
              if($Html_Titre)
                $xmlDataOut .= "\n<TR><TD COLSPAN='4'>$Html_Titre</TD></TR>";
              if($titre=$attribsHTML['Titre']) {
                $xmlDataOut .= "\n<TR><TD COLSPAN='4' $Class_Titre>";
                $xmlDataOut .= $titre.'<BR />&nbsp;';
                $xmlDataOut .= "</TD></TR>";
              }

              if($xml_Fiche_Formulaire=='Form') {
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE='$name'>";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE='noBaliseFermante'>";
              }

            } // Fin if(($xml_Fiche_Formulaire=='Form' && !$NoAffInForm)...

            break;

//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
          default:

            if($xml_Fiche_Formulaire=='Form') {
              $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE='$name'>";
              $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE='noBaliseFermante'>";
            }

        } // Fin switch($name)
      } // Fin if($xml_Fiche_Formulaire!='Modele')

    } // Fin function ModeleFicheXML_startElementHandler($parser, $name, $attribs)


///
///====================================================================================
///    function ModeleFicheXML_characterDataHandler($parser, $data) { global $debugAppli;
    function ModeleFicheXML_characterDataHandler($parser, $data) { global $debugAppli;
///====================================================================================
/// Traitement de texte hors balise
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $data     Texte  traiter
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours, $xmlDataOut;
      global $TypeDocXML;
      global $xml_Fiche_Formulaire;
      global $attributsModele;
      global $id_article, $id_rubrique, $id_secteur;
//------------------------------------------------------------------------------------
//
      $balise = ereg_replace('_[0-9]*_$', '', $baliseEnCours); // Supprimer les indices utiliss
                                                               // pour diffrencier des balises identiques
      switch($balise) {

        case 'DocumentXML' :
        case 'Cadre' :
        case 'Titre3' :
          break;

//------------------------------------------------------------------------------------
        default:  // Contenu par dfaut

          if(eregi("[a-z0-9]", $data)) {
            $dataIn = str_replace ('"', "'", stripSlashes($data));
          } else {
            $dataIn = '';
          }

/// Renseigner la valeur par dfaut du modle
          $attributsModele[$baliseEnCours]['Defaut'] .= RestaurerCodeHTML($dataIn);

      } // Fin switch($baliseEnCours)

    } // Fin function ModeleFicheXML_characterDataHandler($parser, $data)


///
///====================================================================================
///    function ModeleFicheXML_endElementHandler($parser, $name) { global $debugAppli;
    function ModeleFicheXML_endElementHandler($parser, $name) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise fermante
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $name     Nom de la balise fermante
///
///====================================================================================
      global $attributsBaliseEnCours, $xmlDataOut;
      global $TypeDocXML;
      global $lienModifFicheXML, $lienNewFicheXML, $lienAnnulModifFicheXML;
      global $xml_Fiche_Formulaire, $xml_ProcessXML_Requete;
      global $attributsModele, $valeursFiche;
      global $testsInputOblig;
///------------------------------------------------------------------------------------
///
if($debugAppli) if($name=='DocumentXML') $debugAppli->show($attributsModele, "ModeleFicheXML_endElementHandler - </DocumentXML> - attributsModele");
if($debugAppli) if($name=='DocumentXML') $debugAppli->show($GLOBALS['xml_TypeFicheXML'], '$GLOBALS["xml_TypeFicheXML"]');

      if($xml_Fiche_Formulaire!='Modele') {

        $balise = ereg_replace('_[0-9]*_$', '', $name); // Supprimer les indices utiliss
                                                        // pour diffrencier des balises identiques
//------------------------------------------------------------------------------------
/// Identifier les filtres spcifiques (attribut "Traitement")
///
///        NoAffInForm  Ne pas afficher l'entre dans le formulaire (=> input "hidden")
///        NoAff        Ne pas afficher l'entre dans la fiche
///        NoAffLabelInForm  Ne pas afficher le libell du champ dans le formulaire
///        NoAffLabel   Ne pas afficher le libell du champ dans la fiche
///        NoAffVide    Ne pas afficher les lignes (vides) d'un champ vide
///        InitDate     Initialiser la valeur par dfaut (aaa-mm-jj hh:mm:ss)
///        InitDateFr   Initialiser la valeur par dfaut (jj/mm/aaa)
///        Url          Forcer l'ouverture du lien associ ds une nouvelle fentre
///        UrlSansNom   Forcer l'ouverture du lien associ ds une nouvelle fentre
///        UrlRubrique  Crer un lien vers une rubrique
///        MailTo       Crer un lien vers la messagerie
///
        $liste = $attributsModele['DocumentXML']['Traitement'].','.$attributsBaliseEnCours['Traitement'];
        $liste = ereg_replace('^,', '', $liste);
        $traitements = ereg_replace(',$', '', $liste);
        if($traitements=explode(',', $traitements))
          foreach($traitements as $traitement)
            if($traitement) $$traitement = "1";   // Renseigner $<filtre>

/// Renseigner le format (vertical ou pas)  utiliser
///    (cf. attribut 'FormatForm' ou ventuellement attribut 'Format')
        $format = '';
        if($xml_Fiche_Formulaire=='Form')
          if(!$format=$attributsBaliseEnCours['FormatForm'])
            $format = $attributsModele['DocumentXML']['FormatForm'];
        if(!$format)
          if(!$format=$attributsBaliseEnCours['Format'])
            $format = $attributsModele['DocumentXML']['Format'];

/// Renseigner les entres caches (hidden)  gnrer
        $nomHiddens = array();
        if($nomHidden=$attributsBaliseEnCours['AddHidden']) // Entres caches dans le formulaire
          if($nomHidden=='1') $nomHiddens[0] = $name;       // Nom par dfaut
          else $nomHiddens = explode(',', $nomHidden);

/// Dterminer la largeur disponible
        if(!$Width=$attributsModele['DocumentXML']['Width']) $Width = '100%';
        $Width = "WIDTH='$Width'";

        $Class_Titre=$attributsModele['DocumentXML']['Class_Titre'];
        if($Class_Titre) $Class_Titre = "CLASS='$Class_Titre'";

        switch($balise) {

///        case 'DocumentXML' :
        case 'DocumentXML' :

/// Terminer l'affichage des champs
          $xmlDataOut .= "\n</TBODY>\n</TABLE>\n";

/// Si formulaire affich => proposer l'enregistrement
          if($xml_Fiche_Formulaire=='Form') {

            $xmlDataOut .= "\n<DIV ALIGN='CENTER'>&nbsp;<BR />";
////            $xmlDataOut .= "\n<INPUT TYPE='SUBMIT' VALUE='Enregistrer cette fiche' \n";
////            $xmlDataOut .= '   onClick="result=true;'.$testsInputOblig.' return result;" >';
            $xmlDataOut .= "\n<A HREF=\"javascript:document.$TypeDocXML.submit();\"".
                           "     onClick=\"result=true;".$testsInputOblig." return result;\">".
                               "<IMG SRC='icones/enregistrer_off.gif'".
                           "         onMouseOver=\"this.src='icones/enregistrer_on.gif';\"".
                           "         onMouseOut=\"this.src='icones/enregistrer_off.gif';\"".
                           "         BORDER='0'>".
                           "</A>";
            $xmlDataOut .= " &nbsp; ";
////            $xmlDataOut .= "\n<INPUT TYPE='RESET' VALUE='Rinitialiser les champs'>";
////            $xmlDataOut .= " &nbsp; ";
////            $xmlDataOut .= "\n<INPUT TYPE='BUTTON' VALUE='Annuler' ".
////                           "         onClick=\"$lienAnnulModifFicheXML\">";
            $xmlDataOut .= "\n<A HREF=\"javascript:$lienAnnulModifFicheXML\" >".
                           "    <IMG SRC='icones/annuler_off.gif'".
                           "         onMouseOver=\"this.src='icones/annuler_on.gif';\"".
                           "         onMouseOut=\"this.src='icones/annuler_off.gif';\"".
                           "         BORDER='0'>".
                           "  </A>";
            $xmlDataOut .= "\n</DIV>";
            $xmlDataOut .= "\n</FORM>\n";

/// Si affichage seulement => proposer la modification...
          } elseif($GLOBALS['xml_TypeFicheXML']) {

/// => Proposer la modification (aux administrateurs SPIP seulement)
if($debugAppli) $debugAppli->show(adminRubrique($GLOBALS['id_rubrique']), 'adminRubrique('.$GLOBALS['id_rubrique'].')');

              $xmlDataOut .= '<'.'? include("Tools/paramsSpip.php"); ?'.'>';
              $xmlDataOut .= '<'.'? if(adminRubrique($GLOBALS["id_rubrique"])) { ?'.'>';
              $xmlDataOut .= "\n<BR /><DIV ALIGN='CENTER'>";
              $xmlDataOut .= "\n<A HREF=\"$lienModifFicheXML\" >".
                             "    <IMG SRC='icones/modifier_off.gif'".
                             "         onMouseOver=\"this.src='icones/modifier_on.gif';\"".
                             "         onMouseOut=\"this.src='icones/modifier_off.gif';\"".
                             "         BORDER='0'></A>";
              $xmlDataOut .= "\n</DIV>";
              $xmlDataOut .= "\n<".'? } ?'.'>';

          } // Fin if($xml_Fiche_Formulaire=='Form')... elseif($GLOBALS['xml_TypeFicheXML'])...

//------------------------------------------------------------------------------------
/// Si nouvelle fiche
/// => Renseigner les balises de la fiche avec les valeurs par dfaut donnes par le modle
/// => Renseigner les balises par dfaut dans le formulaire

      if($xml_ProcessXML_Requete=='NouvelleFiche') {
        foreach(array_keys($attributsModele) as $balise) {
          $valeursFiche[$balise] = $attributsModele[$balise]['Defaut'];
        } // Fin foreach(array_keys($attributsModele) as $balise)
if($debugAppli) $debugAppli->show($valeursFiche, "ModeleFicheXML_endElementHandler - &lt;/DocumentXML> - valeursFiche");

        renseignerBalisesDsModele();

      } // Fin if($xml_ProcessXML_Requete=='NouvelleFiche')
//if($debugAppli) $debugAppli->close();

          break;

///------------------------------------------------------------------------------------
///        case 'Titre' :
        case 'Titre' :

          break;

//------------------------------------------------------------------------------------
///        case 'Cadre' :
        case 'Cadre' :

/// Terminer l'encadrement des champs
          $xmlDataOut .= "\n<TR><TD COLSPAN='4'>&nbsp;</TD></TR>";
          if($attributsModele[$name]['Border'])
            $xmlDataOut .= "\n</TBODY></TABLE></TD></TR>";

          if($xml_Fiche_Formulaire=='Form') {
            $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"/$name\">";
            $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE='noBaliseFermante'>";
          }

          break;

///------------------------------------------------------------------------------------
///        default:
        default:

/// Ne pas mettre les balises "SPIP" (id_rubrique, id_article, ...) dans le formulaire
          if(strpos("_$balise",'id_')==1) break;

//------------------------------------------------------------------------------------
/// Rcuprer les attributs de mise en page : 'Class_Label', 'Class_Valeur', 'Class_Cmt'
          if(!$Class_Label=$attributsBaliseEnCours['Class_Label'])
            $Class_Label = $attributsModele['DocumentXML']['Class_Label'];
          if($Class_Label) $Class_Label = "CLASS='$Class_Label'";

          unset($Class_Valeur);
          if($xml_Fiche_Formulaire=='Form')
            if(!$Class_Valeur=$attributsBaliseEnCours['Class_Valeur_Form'])
              $Class_Valeur = $attributsModele['DocumentXML']['Class_Valeur_Form'];
          if(!$Class_Valeur)
            if(!$Class_Valeur=$attributsBaliseEnCours['Class_Valeur'])
              $Class_Valeur = $attributsModele['DocumentXML']['Class_Valeur'];
          if($Class_Valeur) $Class_Valeur = "CLASS='$Class_Valeur'";

          if(!$Class_Cmt=$attributsBaliseEnCours['Class_Cmt'])
            $Class_Cmt = $attributsModele['DocumentXML']['Class_Cmt'];
          if($Class_Cmt) {
            $Class_Cmt1 = "<SPAN CLASS='$Class_Cmt'>";
            $Class_Cmt2 = "</SPAN>";
          }

/// Renseigner les attribut de la cellule "label"  utiliser
          if($xml_Fiche_Formulaire=='Form')
            if(!$attribTDlabel=$attributsBaliseEnCours['AttribTDlabelForm'])
              $attribTDlabel = $attributsModele['DocumentXML']['AttribTDlabelForm'];
          if(!$attribTDlabel)
            if(!$attribTDlabel=$attributsBaliseEnCours['AttribTDlabel'])
              $attribTDlabel = $attributsModele['DocumentXML']['AttribTDlabel'];

/// Rcuprer l'alignement right/left des labels (dfaut "right" - format horizontal seulement)
          if(!$alignLabels=$attributsBaliseEnCours['AlignLabels'])
            if(!$alignLabels=$attributsModele['DocumentXML']['AlignLabels'])
              $alignLabels = 'right'; // dfaut

//------------------------------------------------------------------------------------
/// Gnrer le code HTML (cf. attribut 'Class_Label' pour l'attribut 'Label',
///    attribut 'Class_Valeur' pour la valeur, attribut 'Class_Cmt' pour l'attribut 'Cmt'.
          $label = $attributsBaliseEnCours['Label'];
          if($xml_Fiche_Formulaire=='Form') {
            $labelSeul = ereg_replace('<[^>]*>', '', $label);   // Supprimer les ventuelles balises html
            $oblig = str_replace(' ', '&nbsp;', $attributsBaliseEnCours['InputOblig']);
            if($label) $label .= "$oblig&nbsp;";
            if($color=$attributsBaliseEnCours['TypoSpip'] && $format=='Vertical')
              $label .= lienAideTypoSpip($color).'&nbsp;';      // Lien vers l'aide  la mise en page Spip
          }

/// Dterminer la largeur de la colonne "valeur"
          if($format!='Vertical') {
            $width = '75%';                                     // Taille de la colonne 'valeur'...
            if($xml_Fiche_Formulaire=='Form') $width = '50%';   // ...ou 'input'
          }

//------------------------------------------------------------------------------------
/// Eventuellement, ne pas afficher les lignes vides

          if($xml_Fiche_Formulaire!='Form' && $NoAffVide) $xmlDataOut .= "!v!$name!v! ";

//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------

          if(($xml_Fiche_Formulaire=='Form' && !$NoAffInForm)
                || ($xml_Fiche_Formulaire!='Form' && !$NoAff)) {


/// Cellule "label" si format "Vertical"
            if($format=='Vertical') {
              $xmlDataOut .= "\n<TR><TD COLSPAN='4' WIDTH='100%' VALIGN='TOP' $Class_Label $attribTDlabel>";
              if(($xml_Fiche_Formulaire=='Form' && !$NoAffLabelInForm)
                 || ($xml_Fiche_Formulaire!='Form' && !$NoAffLabel))
                $xmlDataOut .= $label;

///    => Champ "help" du formulaire
              if($xml_Fiche_Formulaire=='Form') {
                $cmt = typo($attributsBaliseEnCours['Cmt']);  // Commentaire d'aide
                if(eregi("[a-z0-9]", $cmt))
                  $xmlDataOut .= "&nbsp; $Class_Cmt1 (&nbsp;$cmt) $Class_Cmt2";
              } // Fin if($xml_Fiche_Formulaire=='Form')

///    => Fin du champ "label"
              $xmlDataOut .= "\n    </TD></TR>";

///    => Dbut cellule "Valeur"
              $xmlDataOut .= "\n<TR><TD COLSPAN='4' WIDTH='100%' VALIGN='TOP' $Class_Valeur>";  // Input ou Valeur

/// Cellule "label" si format "Horizontal"
            } else { // ...suite if($format=='Vertical')
              if(($xml_Fiche_Formulaire=='Form' && !$NoAffLabelInForm)
                 || ($xml_Fiche_Formulaire!='Form' && !$NoAffLabel)) {
                $xmlDataOut .= "\n<TR><TD WIDTH='20%' VALIGN='TOP' $Class_Label $attribTDlabel>".
                               "         <DIV ALIGN='$alignLabels'>$label</DIV></TD>";
                $xmlDataOut .= "\n    <TD WIDTH='5'>&nbsp;</TD>";
///    => Dbut cellule "Valeur"
                $xmlDataOut .= "\n    <TD WIDTH='$width' VALIGN='TOP' $Class_Valeur>";  // Input

              } else {
                $xmlDataOut .= "\n<TR><TD COLSPAN='4' WIDTH='$width' VALIGN='BOTTOM' $Class_Valeur>";  // Valeur
              } // Fin if(($xml_Fiche_Formulaire=='Form' && !$NoAffLabelInForm)...

            } // Fin if($format=='Vertical')

          } // Fin if(($xml_Fiche_Formulaire==... || ($xml_Fiche_Formulaire!=...

///------------------------------------------------------------------------------------
/// Gnrer le code ncessaire au test des entres obligatoires

// Type d'input  gnrer
          $TypeInput = $attributsBaliseEnCours['TypeInput'];

          $onEvnt = '';
          $onChangePresent = 0; // => ne rien faire dans la boucle foreach ci-dessous

///    => Si entre obligatoire : Renseigner le champ du formulaire "_test_<balise>"
///    =>                         lors du renseignement du champ "<balise>"
///    =>                         (via une condition "onChange...")
          switch(strToLower($TypeInput)) {
            case 'texte':
            case 'textarea':
            case 'date':
              $action = "document.$TypeDocXML._test_$name.value=this.value;";
              break;
            case 'select':
            case 'select+':
            case 'selectm':
            case 'selectm+':
              $action = "document.$TypeDocXML._test_$name.value=this.selectedIndex;";
              break;
            case 'radio':
            case 'checkbox':
              $action = "document.$TypeDocXML._test_$name.value=this.checked;";
              break;
            default:
          } // Fin switch($TypeInput)

          $attrbs = join(',', array_keys($attributsBaliseEnCours));
          if($oblig && !$NoAffInForm && strpos(strToLower("_,$attrbs,"), ',evnt_onchange,')) {
            $onChangePresent = 1;
          } elseif($oblig && !$NoAffInForm) {
            $onEvnt .= "onChange=\"$action\" ";
          }

/// Traiter les attributs  Evnt_xxx="..."

          foreach(array_keys($attributsBaliseEnCours) as $key) {
            $evt = str_replace('Evnt_','',$key);
            if($evt!=$key) {
              $onEvnt .= "$evt=\"".$attributsBaliseEnCours[$key];
              if($onChangePresent && strToLower($evt)=='onchange')
                $onEvnt .= ";$action";
              $onEvnt .= '" ';
            }
          }

///------------------------------------------------------------------------------------
/// Construire les paramtres du formulaire
/// Traiter selon le type de champ (texte, textarea, select, ...)
/// NB: Si l'attribut TypeInput="NoInput", afficher la valeur dans le formulaire, sans "input"

/// NB: La taille par dfaut des diffrents champs du formulaire
///     est dfinie pour chaque type d'input dans le "switch($TypeInput)" ci-dessous
//------------------------------------------------------------------------------------
          switch(strToLower($TypeInput)) {

//------------------------------------------------------------------------------------
            case 'texte':
            case 'date':
              if($xml_Fiche_Formulaire=='Form') {

                if(count($nomHiddens))
                  foreach($nomHiddens as $i=>$nomHidden)  // "$nomHidden" sera utilis dans les vnements associs...
                    $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME=\"$nomHidden\" VALUE=\"!x!$nomHidden!x!\">";

                if($oblig && !$NoAffInForm) { // Code pour tester le renseignement d'un champ obligatoire
                  $testsInputOblig .= "if(!document.$TypeDocXML._test_$name.value) {alert('".addSlashes("$labelSeul non renseign...")."');result=false;}";
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='_test_$name' VALUE=\"!x!$name!x!\"> ";
                }

                if(!$nbCars=$attributsBaliseEnCours['NbCaracteres']) {      // Taille non spcifie
                  if($TypeInput=='Date') $nbCars = 12;
                  elseif($format=='Vertical') $nbCars = 83;
                      elseif(!$nbCars=$attributsModele['DocumentXML']['DefautNbCars'])
                        $nbCars = 60;
                }
                $nbCars = "SIZE='$nbCars' ";

                if($InitDate)
                  $attributsModele[$name]['Defaut'] = date('Y-m-d H:i:s');  // Attention : date anglaise !!!
                if($InitDateFr)
                  $attributsModele[$name]['Defaut'] = date('d/m/Y');
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"$name\">";
                if($NoAffInForm)
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='ValBalises[]' VALUE=\"!x!$name!x!\"> ";
                else
                  $xmlDataOut .= "\n<INPUT TYPE='TEXTE'  NAME='ValBalises[]' VALUE=\"!x!$name!x!\" ".
                                                                             "$nbCars $onEvnt>";
              } else { // suite if($xml_Fiche_Formulaire=='Form')
                if(!$NoAff) {
                  if($Url) {
                    $xmlDataOut .= "!y!$name!y!<A HREF='!x!$name!x!' TARGET='out'>!x!Nom$name!x!</A>!/y!";
                  } elseif($UrlSansNom) {
                    $xmlDataOut .= "!y!$name!y!<A HREF='!x!$name!x!' TARGET='out'>!x!$name!x!</A>!/y!";
                  } else {
                    $xmlDataOut .= "!x!$name!x!";
                  }
                } // Fin if(!$NoAff)

              } // Fin if($xml_Fiche_Formulaire=='Form')... else ...
              break;

//------------------------------------------------------------------------------------
            case 'checkbox':
            case 'radio':
              $labels = explode(';', $attributsBaliseEnCours['Labels']);
              if($xml_Fiche_Formulaire=='Form') {

                if(count($nomHiddens))
                  foreach($nomHiddens as $i=>$nomHidden)
                    $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='$nomHidden' VALUE=''>";  // Pas de valeur !!!

                if($oblig && !$NoAffInForm) {
                  $testsInputOblig .= "with(document.$TypeDocXML._test_$name) if(!value || value=='false') {alert('".addSlashes("$labelSeul non renseign...")."');result=false;}";
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='_test_$name' VALUE=\"!x!$name!x!\"> ";
                }

                if(!$NoAffInForm) {
                  foreach($labels as $label) {
                    $label1 = str_replace(' ','&nbsp;',stripSlashes($label));
                    $xmlDataOut .= "<INPUT TYPE='".strToUpper($TypeInput)."' ".
                                          "NAME='${name}CheckRadio[]' VALUE=\"$name $label\" ".
                                          "!w!$name!w!$label!w!CHECKED!/w! $onEvnt>$label1 ";
                  }
                } // Fin if(!$NoAffInForm)

                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"/$name\">";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE='noBaliseFermante'>";

              } else { // suite if($xml_Fiche_Formulaire=='Form')
                if(!$NoAff)
                  foreach($labels as $label) {
                    $label1 = str_replace(' ','&nbsp;',stripSlashes($label));
                    $xmlDataOut .= "!w!$name!w!$label!w!".
                                   "<img src='icones/".strToLower($TypeInput).".gif' ".
                                        "height='10' width='10'>&nbsp;$label1 &nbsp; !/w!";
                  }
              } // Fin if($xml_Fiche_Formulaire=='Form')
              break;

//------------------------------------------------------------------------------------
            case 'textarea':
              if($xml_Fiche_Formulaire=='Form') {

                if(count($nomHiddens))
                  foreach($nomHiddens as $i=>$nomHidden)
                    $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='$nomHidden' VALUE=\"!x!$nomHidden!x!\">";

                if($oblig && !$NoAffInForm) {
                  $testsInputOblig .= "if(!document.$TypeDocXML._test_$name.value) {alert('".addSlashes("$labelSeul non renseign...")."');result=false;}";
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='_test_$name' VALUE=\"!x!$name!x!\"> ";
                }

                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"$name\">";
                if($NoAffInForm)
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='ValBalises[]' VALUE=\"!x!$name!x!\"> ";
                else {
                  if(!$nbLignes=$attributsBaliseEnCours['NbLignes'])   $nbLignes = 4;
                  if(!$nbCars=$attributsBaliseEnCours['NbCaracteres']) {      // NbCaracteres non spcifi
                    if($format=='Vertical') $nbCars = 85;
                      elseif(!$nbCars=$attributsModele['DocumentXML']['DefautNbCars'])
                        $nbCars = 60;
                  }
                  $xmlDataOut .= "\n<TEXTAREA NAME='ValBalises[]' ROWS='$nbLignes' COLS='$nbCars' ".
                                              "$onEvnt>!x!$name!x!</textarea>";
                } // Fin if($NoAffInForm)... else ...
              } else {
                if(!$NoAff)
                  $xmlDataOut .= "!x!$name!x!";
              }
              break;

//------------------------------------------------------------------------------------
            case 'file':
              $suffixe = ereg_replace('^.*(_[0-9]+_)$', '\1', $name);

              if($xml_Fiche_Formulaire=='Form') {

                if($oblig && !$NoAffInForm) {
                  $testsInputOblig .= "if(!document.$TypeDocXML._test_$name.value) {alert('".addSlashes("$labelSeul non renseign...")."');result=false;}";
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='_test_$name' VALUE=\"!x!NomUser$suffixe!x!\"> ";
                }

                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"NomUser$suffixe\" >";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE=\"!x!NomUser$suffixe!x!\">";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"CheminFic$suffixe\" >";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE=\"!x!CheminFic$suffixe!x!\">";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"TailleFic$suffixe\" >";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE=\"!x!TailleFic$suffixe!x!\">";

                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"$name\">";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE=\"".$attributsBaliseEnCours['FileExt']."\">";
                if($NoAffInForm)
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME=\"$name\"   VALUE=''> ";
                else
                  $xmlDataOut .= "\n<INPUT TYPE='FILE'    NAME=\"$name\"   VALUE=''>";

              } else {
                if(!$NoAff)
                  $xmlDataOut .= "<A HREF=\"!x!CheminFic$suffixe!x!\" TARGET='doc'>".
                                 "!x!NomUser$suffixe!x!</A> (!x!TailleFic$suffixe!x!K)";
              }
              break;

//------------------------------------------------------------------------------------
            case 'select':    // Select "simple"
            case 'select+':   // Select "simple" avec nouvelle option
            case 'selectm':   // Select multiple
            case 'selectm+':  // Select multiple avec nouvelle option

              $table      = $attributsBaliseEnCours['Table'];
              $chpId      = $attributsBaliseEnCours['ChpId'];        // cl primaire dans la table (dans "value")
              $chpsValue  = $attributsBaliseEnCours['ChpValOption']; // chp1,chp2 (autres chps dans "value")
              $chpTexte   = $attributsBaliseEnCours['ChpTxt'];       // champ affich
              $tableWhere = $attributsBaliseEnCours['TableWhere'];   // tables supplmentaires pour les conditions
              $chpWhere   = $attributsBaliseEnCours['ChpWhere'];     // conditions
              $chpClasst  = $attributsBaliseEnCours['ChpClasst'];    // classement pour l'affichage

              if(!$chpClasst) $chpClasst = $chpId;                   // Dfaut : ChpId
              $CLASST = "ORDER BY $chpClasst,$chpId ";

              $chps = $chpId;
              if($chpsValue) $chps .= ",$chpsValue";                 // tbl.chpId,tbl1.chp1,tbl2.chp2

              $chps0  = ereg_replace('[0-9a-zA-Z_]*\.','',$chps);    // chpId,chp1,chp2
              $chps1  = split(' *, *', "$chps0");                    // array(chpId,chp1,chp2)
              $chps2  = '$'.join(',$', $chps1);                      // $chpId,$chp1,$chp2

              if($xml_Fiche_Formulaire=='Form') {

                if(count($nomHiddens))
                  foreach($nomHiddens as $i=>$nomHidden)
                    $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='$nomHidden' VALUE=''>";  // Pas de valeur

                if($oblig && !$NoAffInForm) {
                  $testsInputOblig .= "with(document.$TypeDocXML._test_$name) if(!value || value=='0') {alert('".addSlashes("$labelSeul non renseign...")."');result=false;}";
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='_test_$name' VALUE=\"!x!$name!x!\"> ";
                }

                if(!$txt=$attributsBaliseEnCours['DefautTexte']) $txt = 'Choisissez...';

                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"$name\">";
                if($NoAffInForm)
                  $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='ValBalises[]' VALUE=\"!x!$name!x!\"> ";
                else {

                  if($TypeInput=='SelectM' || $TypeInput=='SelectM+') {
                    if(!$nbLignes=$attributsBaliseEnCours['NbLignes'])   $nbLignes = 4;
                    $idSelectM = $name.' ';
                    $xmlDataOut .= "\n<INPUT TYPE='HIDDEN'  NAME='ValBalises[]' VALUE=''> ";
                    $xmlDataOut .= "\n<SELECT MULTIPLE NAME='${name}Select[]' SIZE='$nbLignes' $onEvnt>";
                  } else {
                    $idSelectM = '';
                    $xmlDataOut .= "\n<SELECT NAME='ValBalises[]' SIZE='1' $onEvnt>";
                  }
                  $xmlDataOut .= "\n<OPTION VALUE=''>$txt</OPTION>";

                  $FROM  = "FROM $table";
                  if($tableWhere) $FROM .= " , $tableWhere";
                  $WHERE = '';
                  if($chpWhere) $WHERE  = "WHERE $chpWhere ";

                  $sql = "SELECT $chps,$chpTexte $FROM $WHERE $CLASST ";

if($debugAppli) $debugAppli->show($sql, 'SELECT');
                  $res = spip_query($sql);
              		while($row=mysql_fetch_row($res)){
              			eval( "list($chps2,\$txt) = \$row;" );            // list($chpId,$chp1,$chp2,$txt) = $row;
                	  eval( "\$chps3 = \"$chps2\";" );                  // eval( $chps3 = "$chpId,$chp1,$chp2"; );
              			$txt = typo( supprimer_numero($txt) );

                    $xmlDataOut .= "\n<OPTION VALUE=\"$idSelectM$chps3\" !w!$name!w!$chps3!w!SELECTED!/w!>$txt</OPTION>";
              	  }
                  mysql_free_result($res);
                  $xmlDataOut .= "\n</SELECT>";
                } // Fin if($NoAffInForm)... else ...

              } else { // suite if($xml_Fiche_Formulaire=='Form')

                if(!$NoAff) {
                  $sql = "SELECT $chpId,$chpTexte FROM $table WHERE $chpId IN ";
                  if($UrlRubrique)
                    $xmlDataOut .= "!yr!$name!yr!";            // Lien sur une rubrique (valeur=id,titre)
                  else
                    $xmlDataOut .= "!z!$name!z!$sql!z!";       // Valeur(s)  extraire de la base
                }
              } // Fin if($xml_Fiche_Formulaire=='Form')

              break;

//------------------------------------------------------------------------------------
            default:  // Paramtre non affich (pas d'attribut 'TypeInput')

              if($xml_Fiche_Formulaire=='Form') {
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE=\"$name\">";
                $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='ValBalises[]' VALUE=\"!x!$name!x!\"> ";
              }

          } // Fin switch($TypeInput)


//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
/// Si nom de champ dbutant par "email" => ajouter un lien "mailto"...
/// ... On utilise la balise conditionnelle : !v!$nomChamp!v!..................!/v!

          if($xml_Fiche_Formulaire!='Form' && !$NoAff && $MailTo) {
            if(!$NoAffVide) $xmlDataOut .= "!v!$name!v!";   // Pas d'icne si vide !
            $xmlDataOut .= "&nbsp;&nbsp;<A HREF=\"mailto:!x!$name!x!\"><IMG SRC='icones/email.gif' BORDER='0'></A>";
            if(!$NoAffVide) $xmlDataOut .= "!/v!";
          }

/// Fin cellule "valeur"
          if(!$NoAff)
              $xmlDataOut .= "\n    </TD>";
//////              $xmlDataOut .= "\n    &nbsp;</TD>";

/// Si format!="Vertical" => Champ "help" du formulaire
          if($format!='Vertical'
             && $xml_Fiche_Formulaire=='Form'
             && !$NoAffInForm) {

            $cmt = typo($attributsBaliseEnCours['Cmt']);           // Commentaires
            if($color=$attributsBaliseEnCours['TypoSpip'])
              $cmt .= '&nbsp;'.lienAideTypoSpip($color).'&nbsp;';  // Lien vers l'aide  la mise en page Spip

            $xmlDataOut .= "\n    <TD VALIGN='TOP'> $Class_Cmt1 $cmt&nbsp;$Class_Cmt2</TD>";
          }

          if(!$NoAff)
            $xmlDataOut .= "\n</TR>";


//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
/// Traiter un champ de type "Select+" => proposer de dfinir une nouvelle option
//------------------------------------------------------------------------------------

          if((strToLower($TypeInput)=='select+' || strToLower($TypeInput)=='selectm+')
              && $xml_Fiche_Formulaire=='Form' && !$NoAffInForm) {

            if(!$label=$attributsBaliseEnCours['NewLabel'])
              $label = $attributsBaliseEnCours['Label'];
            $cmt = 'Nouveau libell';

            if(!$Class_Intro=$attributsBaliseEnCours['Class_Intro'])
              $Class_Intro = $attributsModele['DocumentXML']['Class_Intro'];
            if(!$Class_Intro) $Class_Intro = $Class_Cmt;
            if($Class_Intro)  $Class_Intro = "CLASS='$Class_Intro'";

            $intro  = "... ou crez une nouvelle entre&nbsp;!";
            $intro .= "<BR />Si vous ne trouvez pas d'entre satisfaisante ".
                    "dans la boite de slection ci-dessus, proposez un nouveau libell&nbsp;:";

            if($format=='Vertical') {
              $xmlDataOut .= "\n<TR><TD COLSPAN='4' WIDTH='100%' VALIGN='TOP' $Class_Intro >$intro</TD></TR>";
              $xmlDataOut .= "\n<TR><TD COLSPAN='4' WIDTH='100%' VALIGN='TOP' $Class_Label >";
              $xmlDataOut .= "       $label &nbsp; $Class_Cmt1 ($cmt) $Class_Cmt2 </TD></TR>";
              $xmlDataOut .= "\n<TR><TD COLSPAN='4' WIDTH='100%' VALIGN='TOP' $Class_Valeur><DIV ALIGN='LEFT'>";  // Input
            } else {
              $xmlDataOut .= "\n<TR><TD COLSPAN='3' WIDTH='100%' VALIGN='TOP' $Class_Intro >$intro</TD><TD>&nbsp;</TD></TR>";
              $xmlDataOut .= "\n<TR><TD WIDTH='20%' VALIGN='TOP' $Class_Label $attribTDlabel>".
                             "<DIV ALIGN='$alignLabels'>$label</DIV></TD>";
              $xmlDataOut .= "\n    <TD WIDTH='5'>&nbsp;</td>";
              $xmlDataOut .= "\n    <TD WIDTH='$width' VALIGN='TOP' $Class_Valeur><DIV ALIGN='LEFT'>";
            } // Fin if($attributsModele['DocumentXML']['Format']=='Vertical')

            $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='New$name'     VALUE=''>";
            $xmlDataOut .= "\n<INPUT TYPE='HIDDEN' NAME='NomBalises[]' VALUE='New$name'>";
            $xmlDataOut .= "\n<INPUT TYPE='TEXTE'  NAME='ValBalises[]' VALUE='' ".
                                    "onBlur='document.$TypeDocXML.New$name.value=this.value;'>";
            $xmlDataOut .= "\n    </DIV></TD>";
            if($format!='Vertical')
              $xmlDataOut .= "\n    <TD VALIGN='TOP'>$Class_Cmt1 $cmt $Class_Cmt2 </TD>";
            $xmlDataOut .= "\n    </TR>";

          } // Fin if($TypeInput=='Select+' ...)

/// Terminer le bloc  ne pas afficher si ligne vide
          if($xml_Fiche_Formulaire!='Form' && $NoAffVide) $xmlDataOut .= "!/v!";

        } // Fin switch($balise)
      } // Fin if($xml_Fiche_Formulaire!='Modele')


    } // Fin function ModeleFicheXML_endElementHandler($parser, $name)


///
///====================================================================================
///    function ModeleFicheXML_processingInstructionHandler($parser, $target, $data) { global $debugAppli;
    function ModeleFicheXML_processingInstructionHandler($parser, $target, $data) { global $debugAppli;
///====================================================================================
/// Traitement d'un script
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $target   Langage du script
///    $data     Script  traiter
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours, $xmlDataOut;
///------------------------------------------------------------------------------------
///
      if(strtolower($target)=='php') {
//***Securit***        eval($data);
      } // Fin if(strtolower($target)=='php')

    } // Fin function ModeleFicheXML_processingInstructionHandler($parser, $target, $data)


///
///====================================================================================
///    function ModeleFicheXML_defaultHandler($parser, $data) { global $debugAppli;
    function ModeleFicheXML_defaultHandler($parser, $data) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise sans handler
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $data     Texte  traiter
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours, $xmlDataOut;
///------------------------------------------------------------------------------------
///

    } // Fin function ModeleFicheXML_defaultHandler($parser, $data)


//
//====================================================================================
// Fin du fichier DocXml_ModeleFicheXML.php
?>