<?php
//===================================================================================
///                                                    Fichier : fonctionsXml.php
///===================================================================================
///
///   Fonctions de traitement d'un document Xml
///
///====================================================================================

///   Inclure les fonctions de traitement des fiches XML
///   => Fichiers "DocXml_xxxxxxx.php"
///   NB: On les inclut ici car ces fonctions doivent tre "global"
///
    $dirh = opendir('.');                       // Parcourir le rpertoire courant
    while($parserXml = readdir($dirh)) {        // On recherche les "parsers" XML
      if(ereg('^DocXml_[a-zA-Z0-9_-]*\.php$', $parserXml))  // Vrifier la syntaxe du nom de fichier
        include $parserXml;                     // C'en est un !
    }
    closedir($dirh);

//global $debugAppli;
//include "Tools/classeDebug.php";
///////... Activer le debug dans la procdure "processXml()", 6 lignes ci-dessous ...
///
///====================================================================================
///    function processXml($data,$modele='') { global $debugAppli;
    function processXml($data,$modele='') { global $debugAppli;

//if(!$debugAppli) $debugAppli = new DEBUG; ///////////////////////// Activer le debug //////////
//if($debugAppli)  $debugAppliOnlyProcessXml = 1; /////////////////// Ne debugger que processXml()

///====================================================================================
///
/// Filtre de traitement d'un texte cod en XML
///
/// Si utilis comme filtre SPIP, inhiber le traitement par dfaut :
///      	[(#TEXTE*|processXML)]
///
/// La chane $data doit commencer par  <DocumentXML TypeDocXML="xxx"  Handler="yyy">
///    sinon elle sera retourne inchange
///
/// Les fonctions de conversion doivent tre incluses en tte de ce prsent fichier
///    cf les "include" ci-dessus :
///       include "DocXml_xxx.php";         // Traitement des fiches
///       include "DocXml_Modelexxx.php";   //     <DocumentXML TypeDocXML="xxx" ... >
///
/// Les fonctions appeles sont :
///    (xxx|Modelexxx)_startElementHandler
///    (xxx|Modelexxx)_endElementHandler
///    (xxx|Modelexxx)_characterDataHandler
///    (xxx|Modelexxx)_processingInstructionHandler
///    (xxx|Modelexxx)_defaultHandler
///
///====================================================================================
///
/// Paramtres
///   $data         Texte  traiter (si $modele vide)
///
///   $modele       Si non vide => Traiter le modle de la fiche
///                   => $data est alors vide (rentrance lors du traitement de $data)
///                   => On recherche un fichier $PathToModelsXml/$modele.xml
///                      (cf table "spip_appli_params")
///                   => Sinon, on recherche l'article Spip
///                         ayant le mot-cl TypeArticle="ModeleFicheXML"
///                      et ayant le champ   Surtitre=$modele
///                 NB: UN ARTICLE "MODLE" (cf. ci-dessus) contenant au minimum la balise
///                         <DocumentXML TypeDocXml="xxx" Handler="yyy"></DocumentXML>
///                     DOIT TOUJOURS EXISTER.
///
/// Paramtres en variables globales
///   $xml_ProcessXML_Requete ='NouvelleFiche' ou 'ModifFiche' (dfaut='ModifFiche')
///   $xml_Fiche_Formulaire   ='Form' si affichage du formulaire (dfaut='')
///
/// Variables globales dfinies avant l'appel au filtre processXML()...
/// ... c'est--dire dans article.php3 ou rubrique.php3...
/// ... ou renseignes par appel  setParamsXML()
///   $xml_TypeFicheXML       Type de fiche  traiter = 'Club' ou 'Projet' ou ...
///   $xml_ObjetSpip          Type d'objet Spip contenant la fiche  traiter = 'article' ou 'rubrique'
///   $xml_ParamsObjetSpip    Si objet 'article' : 'id_objetSpip=<id_article>&id_rubrique=nnn'
///                           Si objet 'rubrique' : 'id_objetSpip=<id_rubrique>&id_parent=nnn&id_secteur=nnn'
///   $xml_Params_PHP_SELF    Paramtres pour afficher la fiche ou son formulaire (Ex: 'Menu=1&Actu=0' )
///   $xml_Params_Retour      Paramtres pour afficher la page de retour (dfaut: $xml_Params_PHP_SELF)
///   $xml_ProcessXML_Retour  Fichier  afficher aprs modification/cration de la fiche
///                              En gnral: 'article.php3' ou 'rubrique.php3'
///
///   $lienNewFicheXML        Liens vers le formulaire "Nouvelle fiche"
///   $lienModifFicheXML      Lien vers le formulaire de modification d'une fiche
///   $lienEnrFicheXML        Lien vers l'enregistrement d'une fiche cre ou modifie
///
/// Traitements
///   Retourne la chaine $data traite si elle commence par
///          <DocumentXML TypeDocXML="xxx" Handler="yyy">,
///      sinon, retourne la chaine $data reue, aprs traitement par le filtre "propre".
///
///   Les procdures de traitement des balises XML (ou "handlers")
///      seront dans le fichier  "DocXML_Modeleyyy.php"
///
///   Dans ce fichier, les procdures de traitement des balises XML (ou "handlers") seront nommes
///      - <handler>_startElementHandler($data)  : Traitement d'une balise ouvrante (et de ses attributs)
///      - <handler>_characterDataHandler($data) : Traitement de la valeur d'une balise (contenu)
///      - <handler>_endElementHandler($data)    : Traitement d'une balise fermante
///      - <handler>_processingInstructionHandler($data) :
///                                                Traitement d'un script dans le contenu d'une balise
///      - <handler>_defaultHandler($data)       : Traitement d'une balise sans handler associ (???)
///
///      avec <handler>=xxx (valeur de l'attribut 'TypeDocXML' dans la balise 'DocumentXML')
///
///      Ces procdures de traitement des balises XML disposeront des variables globales :
///         $DocXmlHandler = Handler PHP (issu de l'attribut 'Handler')
///         $TypeDocXML    = Yyyy  si xxx='ModeleYyyy' (traitement d'un modle de document XML)
///                        = xxx   sinon
///         $baliseEnCours : dernire balise ouvrante traite
///         $nivImbriqBalise : niveau d'imbrication des balises (pour $attributsBalises)
///         $attributsBalises[$nivImbriqBalise]['nom attribut'] : valeur de l'attribut "<nom attribut>" de $baliseEnCours
///         $attributsBaliseEnCours = $attributsBalises['niveau courant']
///      NB: En cas d'appel rcursif  la prsente procdure 'processXml()',
///          ces variables globales doivent tre sauvegardes avant l'appel,
///          puis restaures par l'appelant.
///
///   Dans le cas du traitement d'un modle de fiche, les valeurs associes
///    chaque balise (valeur par dfaut), ainsi que les valeurs des attributs
///   des diffrentes balises, seront rendues disponibles pour l'appelant
///   dans la variable globale $attributsModele (tableau associatif) :
///      $attributsModele[nom balise][nom attribut] = valeur des attributs des balises
///      $attributsModele[nom balise]['defaut']     = valeur par dfaut des balises
///
///====================================================================================
// Dfinir les variables globales
      global $lienEnrFicheXML, $lienModifFicheXML, $lienAnnulModifFicheXML;
      global $xml_ProcessXML_Requete, $xml_Fiche_Formulaire, $PathToModelsXml;
      global $baliseEnCours, $attributsBaliseEnCours, $xml_TypeFicheXML;
      global $attributsBalises, $nivImbriqBalise, $xmlDataOut;
      global $DocXmlHandler, $ModeleFiche, $html_ok_dans_fiche;
//------------------------------------------------------------------------------------
if($debugAppli) $debugAppli->traceParametres("processXml(data,$modele)");
if($debugAppli) $debugAppli->show($xml_TypeFicheXML,'xml_TypeFicheXML');
if($debugAppli) $debugAppli->show($xml_Fiche_Formulaire,'xml_Fiche_Formulaire');
if($debugAppli) $debugAppli->show($xml_ProcessXML_Requete,'xml_ProcessXML_Requete');
if($debugAppli) $debugAppli->show('','------------- Fin des variables globales');
if($debugAppli) $debugAppli->show(str_replace('<','&lt;',$data),"processXml(data,$modele) - data (av & lt; )"); // Rendre visibles les balises XML pour la trace...
//------------------------------------------------------------------------------------
///
/// Lorsque spcifi, rcuprer dans $data le "Modle de document"  traiter
/// en fonction du type de document xml (cf. $TypeDocXML)
/// NB: Ce modle peut tre un article SPIP ou un fichier

//------------------------------------------------------------------------------------
    if($modele) {
//------------------------------------------------------------------------------------
/// Renseigner $xml_TypeFicheXML si vide

      if(!$xml_TypeFicheXML) $xml_TypeFicheXML = ereg_replace('^Modele', '', $modele);

//------------------------------------------------------------------------------------
/// Rechercher le modle

if($debugAppli) $debugAppli->show($PathToModelsXml,'PathToModelsXml');

      if (is_file( $fic="$PathToModelsXml/$modele".'.xml' )) {
if($debugAppli) $debugAppli->show($fic,'Fichier contenant le modle');
/// Si le modle est dans un fichier => le lire

        $fh = fopen($fic, 'r');
          $data = fread($fh, filesize ($fic));
        fclose($fh);

      } else {
/// Sinon le modle est un article Spip => le rcuprer

        $sql = "SELECT art.id_article, art.texte ".
               "FROM spip_articles AS art, spip_mots AS mots, spip_mots_articles AS rel_mots ".
               "WHERE mots.titre='ModeleFicheXML' ".
               "  AND rel_mots.id_mot=mots.id_mot AND art.id_article=rel_mots.id_article ".
               "  AND art.surtitre='$modele' ";
        $res = spip_query($sql);
    		list($idArt, $data) = @mysql_fetch_row($res);   // Contenu de l'article "Modele" dans $data
        @mysql_free_result($res);
if($debugAppli) $debugAppli->show($idArt,'Article Spip contenant le modle');

      } // Fin if (is_file($modele))

//------------------------------------------------------------------------------------
    } // Fin if($modele)
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
/// Renseigner si besoin les variables globales

    if(!$xml_ProcessXML_Requete) $xml_ProcessXML_Requete='ModifFiche';

    setParamsXML();

//------------------------------------------------------------------------------------
///
    $xml_TypeFicheXML      = $GLOBALS['xml_TypeFicheXML'];
    $xml_ObjetSpip         = $GLOBALS['xml_ObjetSpip'];
    $xml_ParamsObjetSpip   = $GLOBALS['xml_ParamsObjetSpip'];
    $xml_ProcessXML_Retour = $GLOBALS['xml_ProcessXML_Retour'];
    $xml_Params_Retour     = $GLOBALS['xml_Params_Retour'];
    $xml_Params_PHP_SELF   = $GLOBALS['xml_Params_PHP_SELF'];
    $html_ok_dans_fiche    = $GLOBALS['html_ok_dans_fiche'];

if($debugAppli) $debugAppli->show($xml_TypeFicheXML,'xml_TypeFicheXML');
if($debugAppli) $debugAppli->show($xml_ObjetSpip ,'xml_ObjetSpip');
if($debugAppli) $debugAppli->show($xml_ParamsObjetSpip,'xml_ParamsObjetSpip');
if($debugAppli) $debugAppli->show($xml_ProcessXML_Retour,'xml_ProcessXML_Retour');
if($debugAppli) $debugAppli->show($xml_Params_Retour,'xml_Params_Retour');
if($debugAppli) $debugAppli->show($xml_Fiche_Formulaire,'xml_Fiche_Formulaire');
///------------------------------------------------------------------------------------
/// Rcuprer l'id de l'objet trait
    $id_objetSpip = ereg_replace('^.*id_objetSpip=([0-9]*).*$', '\1', $xml_ParamsObjetSpip);
if($debugAppli) $debugAppli->show($id_objetSpip,'id_objetSpip');

/// Lien vers l'affichage de la fiche (annulation du formulaire)
/// NB: Attention : KO si popup !
      $lienAnnulModifFicheXML = "window.history.go(-1);"; // Contenu de "onClick="

//------------------------------------------------------------------------------------
/// S'assurer que le document est cod en XML selon nos rgles...
      $noXML = 0;
      $baliseDocumentXML = substr($data, 0, 100);                           // Englobe la premire balise
      if(!strPos($baliseDocumentXML, "DocumentXML ")) {                     // ... KO
        $noXML = 1;
      } elseif(!ereg("^<DocumentXML .*TypeDocXML=", $baliseDocumentXML)) {  // Peut-tre...
        $dataXML = noPropre($data);
        $baliseDocumentXML = substr($dataXML, 0, 100);                      // Englobe la premire balise
        if(!ereg("^<DocumentXML .*TypeDocXML=", $baliseDocumentXML)) {      // ... KO
          $noXML = 1;
        } else {
          $data =$dataXML ;               // ... OK
        }
      }

//------------------------------------------------------------------------------------
/// Au cas o le document serait un modle (cas "NouvelleFiche"), il vient de la base.
/// Si les modles sont dans des fichiers, rechercher le modle adhoc...
/// ... car la base n'est sans doute pas  jour...

      if(!$noXML && $modele=ereg_replace('^.*TypeDocXML=["\']([^"\']+)["\'].*$', '\1', $baliseDocumentXML)) {
if($debugAppli) $debugAppli->show($modele,'TypeDocXML');
        if (is_file( $fic="$PathToModelsXml/$modele".'.xml' )) {
if($debugAppli) $debugAppli->show($fic,'Fichier contenant le modle');
          $fh = fopen($fic, 'r');
            $data = fread($fh, filesize ($fic));
          fclose($fh);
        }
      }

//------------------------------------------------------------------------------------
      if($noXML) {
//------------------------------------------------------------------------------------
/// Si le texte n'est pas en XML => le retourner inchang...
/// ...mais "propre" puisqu'on a inhib ce filtre
//////        $xmlDataOut = propre(CrLfToBr($data));
        $xmlDataOut = propre($data);

///------------------------------------------------------------------------------------
      } else {                    // Le texte est en XML
//------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------
/// Texte en XML => S'assurer qu'aucune balise n'est vide
        $data = ereg_replace('(<[^/][^>]+>)[ \n\r]*(</)', '\1 \2', $data); // Laisser au moins un espace

        $xmlDataOut     = '';      // On raze au cas o...
        $DocXmlHandler  = '';
        $baliseEnCours  = '';
        $nivImbriqBalise = -1 ;    // Niveau d'imbrication des balises (pour $attributsBalises)
        $attributsBalises = array();
        $attributsBaliseEnCours = array();

/// Ouvrir un "parseur"...
        $parser = xml_parser_create("ISO-8859-1");                  // Parser XML - Accepter les
        xml_parser_set_option($parser, XML_OPTION_CASE_FOLDING, 0); //    minuscules dans les balises

/// ... et lui fournir les procdures de traitement des balises
        xml_set_element_handler($parser, 'startElementHandler', 'endElementHandler');
        xml_set_character_data_handler($parser, 'characterDataHandler');
        xml_set_processing_instruction_handler($parser, 'processingInstructionHandler');
        xml_set_default_handler($parser, 'defaultHandler');

/// Dcoder et traiter le texte
        if( !xml_parse($parser, $data, 1) ) {
          die (sprintf("</td></th></tr></table></p><br>&nbsp;<br>XML error line %d, column %d.<br>\n%s",
                        xml_get_current_line_number($parser),
                        xml_get_current_column_number($parser),
                        "<xmp>\n$data\n</xmp>\n"));
        }

/// Librer le "parseur"
        xml_parser_free($parser);

      } // Fin if($noXML)... else ...

if($debugAppli) $debugAppli->show($xmlDataOut,'Fin processXml() ---- xmlDataOut');
if($debugAppli && $debugAppliOnlyProcessXml) $debugAppli->close();

      return $xmlDataOut;

    } // Fin function processXml($data,$modele='')


//====================================================================================
    function protectRegExp($regex) { global $debugAppli;
//====================================================================================

      foreach(array('|','^','$','.','+','*','(',')','[',']','{','}') as $carKO )
        $regex = str_replace($carKO, "\\$carKO", $regex);

      return $regex;

    } // Fin function protectRegExp($regex)



///
///====================================================================================
///    function startElementHandler($parser, $name, $attribs) { global $debugAppli;
    function startElementHandler($parser, $name, $attribs) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise ouvrante
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $name     Nom de la balise ouvrante
///    $attribs  Attributs de la balise
///
/// Renseigne
///   $TypeDocXML    = attribut 'TypeDocXML' de la fiche
///   $Handler       = attribut 'Handler' de la fiche (pas du modle)
///   $DocXmlHandler = attribut 'Handler' courant
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours;
      global $attributsBalises, $nivImbriqBalise, $derniereBalise;
      global $DocXmlHandler, $TypeDocXML, $Handler, $lienNewFicheXML;
      global $xml_ProcessXML_Requete, $xml_Fiche_Formulaire;
///------------------------------------------------------------------------------------
///
if($debugAppli) $debugAppli->show($name,'processXML startElementHandler --- name');
if($debugAppli) $debugAppli->show($attribs,'processXML startElementHandler --- attribs');

      switch($name) {
        case 'HTML' :
          break;

        case 'DocumentXML' :
          $TypeDoc = str_replace('Modele','', $attribs['TypeDocXML']);  // Ex: 'FicheClub'

// Dterminer le "handler" pour la fiche (DocXML_Fichexxx.php) ET pour son modle (DocXML_ModeleFichexxx.php)
          if(!$DocXmlHandler = $attribs['Handler']) $DocXmlHandler = 'FicheXML'; // Handler par dfaut
          $HandlerPHP = str_replace('Modele','', $DocXmlHandler);                // Ex: 'FicheXML'

if($debugAppli) $debugAppli->show($DocXmlHandler,'Balise &lt;DocumentXML> - DocXmlHandler');

// Conserver les attributs de la fiche en variables globales (pas les attributs du modle)
          if(!$TypeDocXML) {
            $TypeDocXML = $TypeDoc;
            $Handler    = $HandlerPHP;
          }
          if($lienNewFicheXML) {
            $lienNewFicheXML   .= "&TypeDocXML=$TypeDocXML&Handler=$Handler";
          }

//if($debugAppli) $debugAppli->show($lienNewFicheXML,'Balise &lt;DocumentXML> - lienNewFicheXML');
//if($debugAppli) $debugAppli->show($TypeDocXML,'Balise &lt;DocumentXML> - TypeDocXML');
//if($debugAppli) $debugAppli->show($Handler,'processXML startElementHandler --- Balise &lt;DocumentXML> - Handler');

          // Pas de 'break;' => on initialise le handler adhoc

//------------------------------------------------------------------------------------
        default:

          eval($DocXmlHandler.'_startElementHandler($parser, $name, $attribs);');

      } // Fin switch($name)

      $baliseEnCours  = $name;
      $derniereBalise = $name;
      $nivImbriqBalise++;
      $attributsBalises[$nivImbriqBalise] = RestaurerCodeHTML($attribs);
      $attributsBaliseEnCours = $attributsBalises[$nivImbriqBalise];

    } // Fin function startElementHandler($parser, $name, $attribs)


///
///====================================================================================
///    function endElementHandler($parser, $name) { global $debugAppli;
    function endElementHandler($parser, $name) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise fermante
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $name     Nom de la balise fermante
///
///====================================================================================
      global $baliseEnCours, $attributsBaliseEnCours;
      global $attributsBalises, $nivImbriqBalise;
      global $DocXmlHandler;
//------------------------------------------------------------------------------------
///
      switch($name) {
        case 'HTML' :
          break;

          default:

            eval($DocXmlHandler.'_endElementHandler($parser, $name);');

      } // Fin switch($name)

      $baliseEnCours  = '';
      $nivImbriqBalise--;
      $attributsBaliseEnCours = $attributsBalises[$nivImbriqBalise];

    } // Fin function endElementHandler($parser, $name)


///
///====================================================================================
///    function characterDataHandler($parser, $data) { global $debugAppli;
    function characterDataHandler($parser, $data) { global $debugAppli;
///====================================================================================
/// Traitement de texte hors balise
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $data     Texte  traiter
///
///====================================================================================
      global $baliseEnCours,$derniereBalise;
      global $DocXmlHandler;
///------------------------------------------------------------------------------------
///
      switch($baliseEnCours) {
        case 'HTML' :
          break;

          default:

if($debugAppli) if(eregi('[a-z0-9.,\-_=]', $data)) $debugAppli->show($data,"$baliseEnCours - data reu ----------");

            $data = stripSlashes($data);          // Nettoyer !
            $data = str_replace('"',"'",$data);

            if($baliseEnCours) {
              eval($DocXmlHandler.'_characterDataHandler($parser, $data);');
            } else {
if($debugAppli) if(eregi('[a-z0-9\.,-_=]', $data)) $debugAppli->show($data,"derniereBalise=$derniereBalise - baliseEnCours=$baliseEnCours - $DocXmlHandler - data non trait ----------");
            }

      } // Fin switch($name)

    } // Fin function characterDataHandler($parser, $data)


///
///====================================================================================
///    function processingInstructionHandler($parser, $target, $data) { global $debugAppli;
    function processingInstructionHandler($parser, $target, $data) { global $debugAppli;
///====================================================================================
/// Traitement d'un script
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $target   Langage du script
///    $data     Script  traiter
///
///====================================================================================
      global $DocXmlHandler;
///------------------------------------------------------------------------------------
///
      if(strToLower($target)=='php') {
//***Securit***      eval($DocXmlHandler.'_processingInstructionHandler($parser, $target, $data);');
      } // Fin if(strtolower($target)=='php')

    } // Fin function processingInstructionHandler($parser, $target, $data)


///
///====================================================================================
///    function defaultHandler($parser, $data) { global $debugAppli;
    function defaultHandler($parser, $data) { global $debugAppli;
///====================================================================================
/// Traitement d'une balise sans handler
///
/// Paramtres
///    $parser   Objet cr via xml_parser_create()
///    $data     Texte  traiter
///
///====================================================================================
      global $DocXmlHandler;
///------------------------------------------------------------------------------------
///
      eval($DocXmlHandler.'_defaultHandler($parser, $data);');

    } // Fin function defaultHandler($parser, $data)

//====================================================================================

function debugXml($name,$attribs='') {
  echo "\n<br>name=$name\n";
  if($attribs)  foreach(array_keys($attribs) as $attrib)
                    echo "\n<br>attribs[$attrib]=".$attribs[$attrib];
}
//
//====================================================================================
// Fin du fichier fonctionsXml.php
?>