<?php
///===================================================================================
///                                                    Fichier : paramsXml.php
///===================================================================================
///
/// Paramtres et fonctions associs  l'utilisation du XML par l'application
/// NB: Voir aussi les fichiers "fonctionsXml.php" et "mes_fonctions.php"
///
/// Exploite et ventuellement renseigne les variables globales suivantes
///
///   $id_article             Id de l'article Spip si $objetSpip='article'
///   $id_rubrique            Id de la rubrique Spip si $objetSpip='rubrique'
///   $userId                 Id Spip de l'internaute
///   $xml_TypeFicheXML       Valeur du mot-cl 'TypeFicheXML'
///   $xml_ObjetSpip          ='article'
///   $xml_ParamsObjetSpip    id_objetSpip, id_rubrique, id_secteur, id_auteur
///   $xml_ProcessXML_Retour  Url de retour ($PHP_SELF)
///   $xml_Params_Retour      Paramtres pour le retour
///   $xml_Params_PHP_SELF    Paramtres courants
///
///====================================================================================

  	if(is_file('ecrire/inc_connect.php3')) {
  	  include 'ecrire/inc_version.php3';
  	  include 'ecrire/inc_connect.php3';
  	  include 'ecrire/inc_session.php3';
  	  include 'ecrire/inc_meta.php3';
  	  include 'ecrire/inc_texte.php3';
  	} else {
  	  include 'ecrire/inc_version.php';
  	  include 'ecrire/inc_connect.php';
  	  include 'ecrire/inc_session.php';
  	  include 'ecrire/inc_meta.php';
  	  include 'ecrire/inc_texte.php';
  	}

//====================================================================================
// Les fonctions ci-dessous ne doivent tre dfinies qu'une fois
if (!defined("_PARAMS_XML_")) {
  define("_PARAMS_XML_", "1");

///====================================================================================
///  function setParamsPHP_SELF() { global $debugAppli;
function setParamsPHP_SELF() { global $debugAppli;
///===================================================================================
///
/// Paramtres de traitement XML
///
/// Renseigne les variables globales suivantes SI $xml_ProcessXML_Retour VIDE :
///
///   $xml_ProcessXML_Retour  Url de retour ($PHP_SELF)
///   $xml_Params_Retour      Paramtres pour le retour
///   $xml_Params_PHP_SELF    Paramtres courants
///
///===================================================================================
    global $xml_ProcessXML_Retour;    // Url de retour ($PHP_SELF)
    global $xml_Params_Retour;        // Paramtres pour le retour
    global $xml_Params_PHP_SELF;      // Paramtres courants
///------------------------------------------------------
///
if($debugAppli) $debugAppli->show($xml_ProcessXML_Retour,'xml_ProcessXML_Retour');
  if(!$xml_ProcessXML_Retour) {

///     Se rappeler de PHP_SELF ($xml_ProcessXML_Retour) ...
        $xml_ProcessXML_Retour = $GLOBALS['PHP_SELF'];
if($debugAppli) $debugAppli->show($xml_ProcessXML_Retour,'===> xml_ProcessXML_Retour');

///     ... et des paramtres reus ($xml_Params_Retour)
        $xml_Params_Retour = '';
        if(count($GLOBALS['HTTP_POST_VARS']))
          foreach($GLOBALS['HTTP_POST_VARS'] as $nom=>$val)
            $xml_Params_Retour .= "&$nom=".urlEncode($val);
        if(count($GLOBALS['HTTP_GET_VARS']))
          foreach($GLOBALS['HTTP_GET_VARS'] as $nom=>$val)
            $xml_Params_Retour .= "&$nom=".urlEncode($val);
        $xml_Params_Retour .= '&xml_Fiche_Formulaire=';   // Ne pas propager ce flag !

        $xml_Params_Retour = ereg_replace('&xml_Params_Retour=[^&]*&','&',$xml_Params_Retour);
        $xml_Params_Retour = str_replace('&recalcul=oui','',$xml_Params_Retour);
        $xml_Params_Retour = str_replace('&submit=Recalculer+cette+page','',$xml_Params_Retour);
        $xml_Params_Retour = substr($xml_Params_Retour,1); // Supprimer le 1er '&'

        $xml_Params_PHP_SELF = $xml_Params_Retour;
if($debugAppli) $debugAppli->show($xml_Params_Retour,'===> xml_Params_Retour et xml_Params_PHP_SELF');

        $GLOBALS['xml_ProcessXML_Retour'] = $xml_ProcessXML_Retour;
        $GLOBALS['xml_Params_Retour']     = $xml_Params_Retour;
        $GLOBALS['xml_Params_PHP_SELF']   = $xml_Params_PHP_SELF;

  } // Fin if(!$xml_ProcessXML_Retour)

} // Fin function setParamsPHP_SELF()

///===================================================================================
///  function setParamsXML($typeFicheXML='', $id_article_modele='') { global $debugAppli;
function setParamsXML($typeFicheXML='', $id_article_modele='') { global $debugAppli;
///===================================================================================
///
/// Renseignement des paramtres de traitement XML
///
/// Si non dj spcifis dans les paramtres de la page, dfinir les paramtres
///    ncessaires  processXML() pour modifier la fiche.
///
/// NB: Lorsque cette fonction est excut par SPIP (via le filtre "processXML"),
///     les paramtres renseigns ici ne seront pas accessibles dans le squelette...
///     Cependant cette fonction est appelable directement dans un squelette.
///
/// Paramtres
///   $typeFicheXML             Type de la fiche  traiter
///                               Si vide, le type sera donn par la variable globale
///                               "$xml_TypeFicheXML" (cf. ci-dessous)
///   $id_article_modele        N de l'article Spip contenant le modle de fiche adhoc
///                               Si vide, sera renseign en recherchant l'article
///                               de mot-cl "ModeleFicheXML"
///                               et de surtitre "Modele<type_de_fiche>"
///
/// Variables globales
///   $xml_TypeFicheXML         Objet "applicatif" associ  la rubrique ou article (Fiche)
///                               Si vide, sera renseign d'aprs le mot-cl "TypeFicheXML"
///   $xml_ProcessXML_Requete;  Doit tre renseign  'NouvelleFiche' si c'est le cas
///   $xml_ObjetSpip            = "article" ou "rubrique" (optionnel)
///                               Si vide, sera renseign d'aprs $PHP_SELF
///   $xml_ParamsObjetSpip      id_objetSpip, id_article, id_rubrique, id_secteur
///   $id_objetSpip             id_article ou id_rubrique associ
///                               Si vide, sera renseign d'aprs ${id_$xml_ObjetSpip}
///   $id_article               Id de l'article Spip si $xml_ObjetSpip='article'
///                               Si vide, sera renseign d'aprs ${id_$xml_ObjetSpip}
///   $id_rubrique              Id de la rubrique Spip si $xml_ObjetSpip='rubrique'
///                               ou id de la rubrique contenant l'article Spip
///                               si $xml_ObjetSpip='article'
///                               Si vide, sera renseign d'aprs ${id_$xml_ObjetSpip}
///   $id_secteur               Id de la rubrique racine contenant l'article
///                               ou la rubrique Spip
///                               Si vide, sera renseign d'aprs ${id_$xml_ObjetSpip}
///   $userId                   Id Spip de l'internaute
///                               Si vide, sera renseign d'aprs ${id_$xml_ObjetSpip}
///
/// Variables Spip
///   mot-cl "TypeFicheXML"  Type de fiche : sera utilis pour rcuprer les paramtres
///                           d'importation dans Spip dfinis par "paramsAppli.php"
///                           dans la variable globale "$import_<TypeFicheXML>"
///
/// Renseigne les variables globales suivantes SI ELLES SONT VIDES :
///   $xml_TypeFicheXML         Valeur du mot-cl 'TypeFicheXML'
///   $xml_ObjetSpip            ='article', 'rubrique', ...
///   $xml_ParamsObjetSpip      id_objetSpip, id_article, id_rubrique, id_secteur, id_auteur
///   $xml_ProcessXML_Requete;  ='NouvelleFiche' ou ='ModifFiche' ou vide
///   $xml_ProcessXML_Retour    Url de retour ($PHP_SELF)
///   $xml_Params_Retour        Paramtres pour le retour
///   $xml_Params_PHP_SELF      Paramtres courants
///
///   $lienNewFicheXML          Lien pour crer une fiche
///   $titreLienNewFicheXML     Titre du lien pour crer une fiche (titre du modle)
///   $lienModifFicheXML        Lien pour modifier la fiche
///
///===================================================================================
    global $id_article, $id_rubrique; // Ids Spip
    global $id_secteur;               // Id Spip
    global $userId, $userRights;      // Id et droits de l'utilisateur
    global $xml_TypeFicheXML;         // Type de fiche : Valeur du mot-cl 'TypeFicheXML'
    global $xml_ObjetSpip;            // =<objet Spip>
    global $xml_ParamsObjetSpip;      // id_objetSpip, id_rubrique, id_article, id_secteur, id_auteur
    global $lienNewFicheXML;          // Lien pour crer une fiche
    global $lienNewFicheXML;          // Lien pour crer une fiche
    global $titreLienNewFicheXML;     // Titre du lien pour enregistrer une fiche
    global $lienModifFicheXML;        // Lien pour modifier la fiche
    global $xml_ProcessXML_Requete;   // Nouvelle fiche ou mofification d'une fiche
    global $xml_ProcessXML_Retour;    // Url de retour ($PHP_SELF)
    global $xml_Params_Retour;        // Paramtres pour le retour
    global $xml_Params_PHP_SELF;      // Paramtres courants
//------------------------------------------------------
/// Renseigner $xml_ObjetSpip
///    Si "$xml_ObjetSpip" vide, le renseigner d'aprs $PHP_SELF

if($debugAppli) $debugAppli->show('',"--- Dbut setParamsXML(typeFicheXML='$typeFicheXML', id_article_modele='$id_article_modele') ---");
if($debugAppli) $debugAppli->show($xml_ObjetSpip,'xml_ObjetSpip');
    if(!$xml_ObjetSpip) {
      $xml_ObjetSpip = ereg_replace('.*/','', ereg_replace('\\.php.*$','', $GLOBALS['PHP_SELF']));
    }
if($debugAppli) $debugAppli->show($xml_ObjetSpip,'===> xml_ObjetSpip');

//------------------------------------------------------
/// Renseigner $id_objetSpip
///    ==> Si $xml_ProcessXML_Requete == 'NouvelleFiche' : $id_objetSpip=0
///    ==> Sinon, le renseigner d'aprs ${id_$xml_ObjetSpip}

if($debugAppli) $debugAppli->show($id_objetSpip,'id_objetSpip');
    if($xml_ProcessXML_Requete=='NouvelleFiche') {
      $id_objetSpip = 0;
    } else {
      if(!$id_objetSpip) eval( "\$id_objetSpip=\$id_$xml_ObjetSpip;");
      if(!$id_objetSpip && $xml_ParamsObjetSpip)
        eval( "\$id_objetSpip=ereg_replace('^.*id_objetSpip=([0-9]*).*$', '\\1', \$xml_ParamsObjetSpip);" );
    }
if($debugAppli) $debugAppli->show($id_objetSpip,'===> id_objetSpip');

//------------------------------------------------------
/// Renseigner $id_rubrique , $id_secteur, $id_auteur
///    On exploite  $xml_ParamsObjetSpip
///    Sinon, on recherche exploite l'objet Spip "$xml_ObjetSpip" d'id "$id_objetSpip"
///    Si pas d'auteur dans $xml_ParamsObjetSpip  => l'auteur est l'internaute
/// Rechercher le titre de l'article ou rubrique  traiter, son auteur,
///    ainsi que le secteur et la rubrique le ou la contenant

if($debugAppli) $debugAppli->show($xml_ParamsObjetSpip,'xml_ParamsObjetSpip');
    if($xml_ParamsObjetSpip) {
      if(strpos("_$xml_ParamsObjetSpip", 'id_rubrique='))
        eval( "\$id_rubrique=ereg_replace('^.*id_rubrique=([0-9]*).*$', '\\1', \$xml_ParamsObjetSpip);" );
      if(strpos("_$xml_ParamsObjetSpip", 'id_secteur='))
        eval( "\$id_secteur=ereg_replace('^.*id_secteur=([0-9]*).*$', '\\1', \$xml_ParamsObjetSpip);" );
      if(strpos("_$xml_ParamsObjetSpip", 'id_auteur='))
        eval( "\$id_auteur=ereg_replace('^.*id_auteur=([0-9]*).*$', '\\1', \$xml_ParamsObjetSpip);" );
    }

    if($id_objetSpip) {
      if($id_secteur) {
        $sql = "SELECT titre ".
               "  FROM spip_$xml_ObjetSpip"."s WHERE id_$xml_ObjetSpip=$id_objetSpip ";
        $res = spip_query($sql);
        list($titre) = mysql_fetch_row($res);
        mysql_free_result($res);
      } else {
        $sql = "SELECT id_rubrique,id_secteur,titre ".
               "  FROM spip_$xml_ObjetSpip"."s WHERE id_$xml_ObjetSpip=$id_objetSpip ";
        $res = spip_query($sql);
        list($id_rubrique,$id_secteur,$titre) = mysql_fetch_row($res);
        mysql_free_result($res);
      }
    }

    if(!$id_auteur) $id_auteur = $userId;

if($debugAppli) $debugAppli->show($id_rubrique,'===> id_rubrique');
if($debugAppli) $debugAppli->show($id_secteur,'===> id_secteur');
if($debugAppli) $debugAppli->show($id_auteur,'===> id_auteur');
if($debugAppli) $debugAppli->show($userId,'userId');

//------------------------------------------------------
///     NB: On ne traite que les articles ou rubriques de titre non "Dummy"
if($debugAppli) $debugAppli->show($titre,'titre');
    if($titre!='Dummy') {

//------------------------------------------------------
/// Renseigner $xml_TypeFicheXML si $typeFicheXML est vide
///    Rcuprer le type d'objet applicatif (mot-cl "TypeFicheXML")
///    NB: Il ne peut y avoir qu'un seul mot-cl de ce type

if($debugAppli) $debugAppli->show($typeFicheXML,'typeFicheXML');
if($debugAppli) $debugAppli->show($xml_TypeFicheXML,'xml_TypeFicheXML');
      if($typeFicheXML) $xml_TypeFicheXML = $typeFicheXML;  // Fourni par l'appelant
      if(!$xml_TypeFicheXML) {                              // Non fourni

        $sql = "SELECT mots.titre ".
               "FROM  spip_mots AS mots, spip_mots_$xml_ObjetSpip"."s AS rel_mots ".
               "WHERE mots.id_mot=rel_mots.id_mot ".
               "  AND rel_mots.id_$xml_ObjetSpip=$id_objetSpip ".
               "  AND mots.type='TypeFicheXML' ";
        $res = spip_query($sql);
        list($xml_TypeFicheXML) = mysql_fetch_row($res);
        mysql_free_result($res);
      }
if($debugAppli) $debugAppli->show($xml_TypeFicheXML,'===> xml_TypeFicheXML');

//------------------------------------------------------
/// Renseigner $xml_ParamsObjetSpip : Paramtres associs  l'objet Spip

      $xml_ParamsObjetSpip = "id_rubrique=$id_rubrique&id_secteur=$id_secteur&id_auteur=$id_auteur".
                             "&id_$xml_ObjetSpip=".${"id_$xml_ObjetSpip"}."&id_objetSpip=$id_objetSpip";

///     Se rappeler de PHP_SELF ($xml_ProcessXML_Retour) ...
///     ... et des paramtres reus ($xml_Params_Retour et $xml_Params_PHP_SELF)

      setParamsPHP_SELF();

//------------------------------------------------------
/// Renseigner $id_article_modele :
///    Retrouver l'article contenant le "Modle de fiche"

if($debugAppli) $debugAppli->show($id_article_modele,'id_article_modele');
      if(!$id_article_modele) {

        $sql = "SELECT art.id_article,art.titre ".
               "FROM spip_articles AS art, spip_mots AS mots, spip_mots_articles AS rel_mots ".
               "WHERE mots.titre='ModeleFicheXML' ".            // Le modle a le mot-cl "ModeleFicheXML"...
               "  AND rel_mots.id_mot=mots.id_mot ".
               "  AND art.id_article=rel_mots.id_article ".
               "  AND art.surtitre='Modele$xml_TypeFicheXML' "; // ... et le surtitre "Modele<TypeFicheXML>"
        $res = spip_query($sql);
    		list($id_article_modele,$titreLienNewFicheXML) = @mysql_fetch_row($res);
        @mysql_free_result($res);

      } else {
        $sql = "SELECT titre ".
               "FROM spip_articles ".
               "WHERE id_article=$id_article_modele ";
        $res = spip_query($sql);
    		list($titreLienNewFicheXML) = @mysql_fetch_row($res);
        @mysql_free_result($res);
      }
if($debugAppli) $debugAppli->show($id_article_modele,'===> id_article_modele');
if($debugAppli) $debugAppli->show($titreLienNewFicheXML,'titreLienNewFicheXML');

//------------------------------------------------------
/// Paramtres communs  tous les liens

      $params = "&xml_TypeFicheXML=$xml_TypeFicheXML".
                "&xml_ObjetSpip=$xml_ObjetSpip".
                "&xml_ParamsObjetSpip=".urlEncode($xml_ParamsObjetSpip).
                "&xml_Params_Retour=".urlEncode($xml_Params_Retour).
                "&xml_Params_PHP_SELF=".urlEncode($xml_Params_PHP_SELF).
                "&xml_ProcessXML_Retour=$xml_ProcessXML_Retour".
                "&xml_aideTypo=1";

//------------------------------------------------------
/// Renseigner $lienNewFicheXML : Lien "Nouveau <TypeFicheXML>"

      $lienNewFicheXML = "article.php3?id_article=$id_article_modele".   // Modle XML : article !
                                       $params.
                                     "&xml_Fiche_Formulaire=Form".
                                     "&xml_ProcessXML_Requete=NouvelleFiche";


//------------------------------------------------------
/// Renseigner $lienModifFicheXML : Lien "Modifier..."

      $lienModifFicheXML = "$xml_ObjetSpip.php3?recalcul=oui".
                                            $params.
                                          "&xml_Fiche_Formulaire=Form".
                                          "&xml_ProcessXML_Requete=ModifFiche".
                                          "&id_$xml_ObjetSpip=$id_objetSpip";

//------------------------------------------------------
/// Renseigner $lienEnrFicheXML : Lien vers l'enregistrement d'une fiche modifie

      $lienEnrFicheXML = "nouvelleFiche.php?xml_ProcessXML_Requete=$xml_ProcessXML_Requete".
                                            $params;
//------------------------------------------------------

      $GLOBALS['xml_TypeFicheXML']      = $xml_TypeFicheXML;
      $GLOBALS['xml_ObjetSpip']         = $xml_ObjetSpip;
      $GLOBALS['xml_ParamsObjetSpip']   = $xml_ParamsObjetSpip;
      $GLOBALS['lienNewFicheXML']       = $lienNewFicheXML;
      $GLOBALS['titreLienNewFicheXML']  = $titreLienNewFicheXML;
      $GLOBALS['lienModifFicheXML']     = $lienModifFicheXML;
      $GLOBALS['lienEnrFicheXML']       = $lienEnrFicheXML;

if($debugAppli) $debugAppli->show('','--- Sortie setParamsXML() ---');
if($debugAppli) $debugAppli->show($lienNewFicheXML,'lienNewFicheXML');
if($debugAppli) $debugAppli->show($titreLienNewFicheXML,'titreLienNewFicheXML');
if($debugAppli) $debugAppli->show($lienModifFicheXML,'lienModifFicheXML');
if($debugAppli) $debugAppli->show($lienEnrFicheXML,'lienEnrFicheXML');

    } // Fin if($titre!='Dummy')

if($debugAppli) $debugAppli->show('','--- Fin setParamsXML() ---');
} // Fin function setParamsXML()

//------------------------------------------------------
} // Fin if (!defined("_PARAMS_XML_"))

?>